@startuml
title 1 createSheet
actor Actor
participant "CatERingAppManager.sheetManager:SheetManager" as sm
participant "CatERingAppManager.userManager:UserManager" as um
participant "sheet: Sheet" as s
participant "activities: List<Activity>" as la
participant "r:SheetEventReceiver" as r

Actor -> sm++: createSheet(event)

sm -> um ++: getCurrentUser()

um -->> sm --: user

alt !user.isChef()
	sm -->> Actor: throw UseCaseLogicException
else  event.getAssignedChef() != user
        sm -->> Actor: throw UseCaseLogicException
else
	sm --> s **: createSheet(event)
    activate s
    
    s -> s: setEvent(event)
    
    s -->  la **:create()
    
    s -->> sm --: sheet
    
    sm -> sm: setCurrentSheet(sheet)
    
    group for each r in receivers
    	sm -> r++:notifySheetCreated(sheet)
        deactivate r
    end   
    
    sm -->> Actor --: sheet
    
end
@enduml
